/*		Mike Pompa's SUBROUTINES			*/

#define	ver	0
#define rev	0
#define mod	'a'
#define asm	'j'

/* File Change History:

	0.0a 11/04/83	Moved subroutines from filesubs.c
*/

#include "mikesubs.os"
#include "c:switch.os"
#include "mikesubs.inc"

#define CR 13
#define LF 10
#define BS 8
#define SP ' '
	
/*********************************************************************/
/*page*/
/* convert list of strings to upper case */

listUpper( count, ptr)
int	count;
CHAR	*ptr[];
{
	while ( count--)
		{
#ifdef debug
		printf( "convert to upper: %s\n", ptr[ count]);
#endif
		strUpper( ptr[ count]);
#ifdef debug
		printf( "voila: %s\n", ptr[ count]);
#endif
		}
} 


/*********************************************************************/
/* temporarily here until DMS C library is converted */
strUpper(ptr)
CHAR	*ptr;
{	while (*ptr) {*ptr = toupper(*ptr); *ptr++; } }
/*********************************************************************/

CHAR	*copytiln( d, s, e, n)
CHAR	*d, *s, e;
int	n;
{
	while( n-- )
		{
		if(*s != e)
			*d++ = *s++;
		}
	return d;
}

/*********************************************************************/

/*page*/
disp(str,len)
CHAR	*str;
int	*len;
{
char	buff[81];
	copyn(buff,str,len);
	printf("%s.\n",buff);
}

/**********************************************************************/
copyn( d, s, n)
CHAR 	*d, *s;
int	n;
{
#ifdef debug
	printf("copyn\n");
#endif
	while ( n--)
		*d++ = *s++;
	*d = 0;
}
/*********************************************************************/

moven( d, s, n)
CHAR	*d, *s;
int	n;
{	
#ifdef debug
	printf("moven\n");
#endif
	while ( n-- ) *d++ = *s++;   

}

/*********************************************************************/

blkcmp( s1, s2, l)
CHAR	*s1, *s2;
int	l;
{
	while( l--)
		if( *s1++ != *s2++)
			break;
	return *(--s1) - *(--s2);
}
/*********************************************************************/
/*page*/
CHAR	*copytil(d,s,e)
CHAR	*s,*d;
CHAR	e;
{
#ifdef debug
	printf("copytil\n");
#endif
	while((*d++ = *s++) != e);
	*--d = 0;
	return (--s);
}
/**********************************************************************/

CHAR	*movetil(d,s,e)
CHAR	*s,*d;
CHAR	e;
{
#ifdef debug
	printf("movetil\n");
#endif
	while( *s != e)
		*d++ = *s++;
	return s;
}

/**********************************************************************/

fill( area, chr, len)
CHAR	*area;
CHAR	chr;
int	len;
{
#ifdef debug
	printf("fill\n");
#endif
	while( len--)
		*area++ = chr;
}

/**********************************************************************/

CHAR	*findlast( str, chr)
CHAR	*str;
CHAR	chr;
{
CHAR	*here;
#ifdef debug
	printf("findlast\n");
#endif
	here = 0;
	while( *str)
		if( *str++ == chr)
			here = str-1;
	return here;
}
/**********************************************************************/
/*page*/
CHAR	*input( buff, len)
CHAR	*buff;
int	len;
{
CHAR	c;

	fill( buff, ' ', len);
	while( forever)
		{
		c = getchar();
		if (c == CR || c == LF)
			return *buff;
		if( len) 
			{len--;
			*buff++ = toupper( c);
			}
		}
}
/**********************************************************************/
CHAR	*pwinput( buff, len)
CHAR	*buff;
int	len;
{
CHAR	c;

	fill( buff, ' ', len);
	while( forever)
		{
		c = getchar();
		if (c == CR || c == LF)
			return *buff;
		if( len) 
			{len--;
			*buff++ = c;
			/* putchar( BS); putchar( SP); putchar( BS); */
			}
		}
}
/**********************************************************************/

sinput( buff, len)
CHAR	*buff;
int	len;
{
CHAR	*end;

	end = input( buff, len);
	if( end != 0)
		*end = 0;
}
/**********************************************************************/
/*page*/
zopen( filename, openmode)
CHAR	*filename;
CHAR 	*openmode;
{
int	retcode;
#ifdef aztec
	if( *openmode == 'r' )
		{
		retcode = open( filename, O_RDONLY );
		}
	if( *openmode == 'w' )
		{
		retcode = open( filename, O_WRONLY + O_CREAT );
		}
#else
	if( *openmode == 'r' )
		{
		retcode = open( filename, BREAD );
		}
	if( *openmode == 'w' )
		{
		retcode = creat( filename, BWRITE );
		}
#ifdef dbg
	printf( "c86 open %s returns &x\n", openmode, retcode);
#endif
#endif
	return retcode;
}
/**********************************************************************/

zclose( fp)
int	*fp;
{
#ifdef dbg
	printf("zclose\n");
#endif
	return close( fp);
}
/**********************************************************************/

int 	zread( fp, record, l)
int	fp;
int	record, l;
{
#ifdef dbg
	printf("read record\n");
#endif
	return read( fp, record, l);
}
/**********************************************************************/

zwrite( fp, record, l)
CHAR	*record;
int	l;
int	fp;
{
#ifdef dbg
	printf("write record\n");
#endif
	write( fp, record, l);
}
/**********************************************************************/
/*page*/
interr()
{
	printf("*** Internal error\n");
}
/**********************************************************************/

dummy()
{
	printf("this routine simulated\n");
}
/**********************************************************************/

notyet()
{
	printf("NOT IMPLEMENTED YET\n");
}


***********************************************************/

zclose( fp)
int	*fp;
{
#ifdef dbg
	printf("zclose\n");
#endif
	return close( fp);
}
/**********************************************************************/

int 	zread( fp, record, l)
int	fp;
int	record, l;
{
#ifdef dbg
	printf("read record\n");
#endif
	return read( fp, record, l);
}
/**********************************************************************/

zwrite( fp, record, l)
CHAR	*record;
int	l;
int	fp;
{
#ifdef dbg
	printf("write record\n");
#endif
	write( fp, record, l);
}
/**********************************************************************/
/*page*/
interr()
{
	printf("*** Internal error\n");
}
/*****************************************************